#include <nav_msgs/GridCells.h>
#include <nav_msgs/Odometry.h>
#include <nav_msgs/Path.h>
#include <nav_msgs/OccupancyGrid.h>
#include <nav_msgs/MapMetaData.h>

#include <rtt/types/TypekitPlugin.hpp>
#include <rtt/types/StructTypeInfo.hpp>

namespace ros_integration {
  using namespace RTT;

    /** Declare all factory functions */
            void rtt_ros_addType_GridCells();
        void rtt_ros_addType_Odometry();
        void rtt_ros_addType_Path();
        void rtt_ros_addType_OccupancyGrid();
        void rtt_ros_addType_MapMetaData();

   
    /**
     * This interface defines the types of the realTime package.
     */
    class ROSnav_msgsTypekitPlugin
      : public types::TypekitPlugin
    {
    public:
      virtual std::string getName(){
          return std::string("ros-")+"nav_msgs";
      }

      virtual bool loadTypes() {
          // call all factory functions
                  rtt_ros_addType_GridCells(); // factory function for adding TypeInfo.
        rtt_ros_addType_Odometry(); // factory function for adding TypeInfo.
        rtt_ros_addType_Path(); // factory function for adding TypeInfo.
        rtt_ros_addType_OccupancyGrid(); // factory function for adding TypeInfo.
        rtt_ros_addType_MapMetaData(); // factory function for adding TypeInfo.

          return true;
      }
      virtual bool loadOperators() { return true; }
      virtual bool loadConstructors() { return true; }
    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSnav_msgsTypekitPlugin )

