#include <sensor_msgs/Joy.h>
#include <sensor_msgs/Imu.h>
#include <sensor_msgs/PointField.h>
#include <sensor_msgs/ChannelFloat32.h>
#include <sensor_msgs/PointCloud.h>
#include <sensor_msgs/JoyFeedback.h>
#include <sensor_msgs/RegionOfInterest.h>
#include <sensor_msgs/CameraInfo.h>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/JoyFeedbackArray.h>
#include <sensor_msgs/Range.h>
#include <sensor_msgs/JointState.h>
#include <sensor_msgs/LaserScan.h>
#include <sensor_msgs/Image.h>
#include <sensor_msgs/CompressedImage.h>
#include <sensor_msgs/NavSatStatus.h>
#include <sensor_msgs/NavSatFix.h>

#include <rtt/types/TypekitPlugin.hpp>
#include <rtt/types/StructTypeInfo.hpp>

namespace ros_integration {
  using namespace RTT;

    /** Declare all factory functions */
            void rtt_ros_addType_Joy();
        void rtt_ros_addType_Imu();
        void rtt_ros_addType_PointField();
        void rtt_ros_addType_ChannelFloat32();
        void rtt_ros_addType_PointCloud();
        void rtt_ros_addType_JoyFeedback();
        void rtt_ros_addType_RegionOfInterest();
        void rtt_ros_addType_CameraInfo();
        void rtt_ros_addType_PointCloud2();
        void rtt_ros_addType_JoyFeedbackArray();
        void rtt_ros_addType_Range();
        void rtt_ros_addType_JointState();
        void rtt_ros_addType_LaserScan();
        void rtt_ros_addType_Image();
        void rtt_ros_addType_CompressedImage();
        void rtt_ros_addType_NavSatStatus();
        void rtt_ros_addType_NavSatFix();

   
    /**
     * This interface defines the types of the realTime package.
     */
    class ROSsensor_msgsTypekitPlugin
      : public types::TypekitPlugin
    {
    public:
      virtual std::string getName(){
          return std::string("ros-")+"sensor_msgs";
      }

      virtual bool loadTypes() {
          // call all factory functions
                  rtt_ros_addType_Joy(); // factory function for adding TypeInfo.
        rtt_ros_addType_Imu(); // factory function for adding TypeInfo.
        rtt_ros_addType_PointField(); // factory function for adding TypeInfo.
        rtt_ros_addType_ChannelFloat32(); // factory function for adding TypeInfo.
        rtt_ros_addType_PointCloud(); // factory function for adding TypeInfo.
        rtt_ros_addType_JoyFeedback(); // factory function for adding TypeInfo.
        rtt_ros_addType_RegionOfInterest(); // factory function for adding TypeInfo.
        rtt_ros_addType_CameraInfo(); // factory function for adding TypeInfo.
        rtt_ros_addType_PointCloud2(); // factory function for adding TypeInfo.
        rtt_ros_addType_JoyFeedbackArray(); // factory function for adding TypeInfo.
        rtt_ros_addType_Range(); // factory function for adding TypeInfo.
        rtt_ros_addType_JointState(); // factory function for adding TypeInfo.
        rtt_ros_addType_LaserScan(); // factory function for adding TypeInfo.
        rtt_ros_addType_Image(); // factory function for adding TypeInfo.
        rtt_ros_addType_CompressedImage(); // factory function for adding TypeInfo.
        rtt_ros_addType_NavSatStatus(); // factory function for adding TypeInfo.
        rtt_ros_addType_NavSatFix(); // factory function for adding TypeInfo.

          return true;
      }
      virtual bool loadOperators() { return true; }
      virtual bool loadConstructors() { return true; }
    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSsensor_msgsTypekitPlugin )

