#include <visualization_msgs/MarkerArray.h>
#include <visualization_msgs/InteractiveMarkerUpdate.h>
#include <visualization_msgs/InteractiveMarkerPose.h>
#include <visualization_msgs/Marker.h>
#include <visualization_msgs/MenuEntry.h>
#include <visualization_msgs/InteractiveMarker.h>
#include <visualization_msgs/ImageMarker.h>
#include <visualization_msgs/InteractiveMarkerFeedback.h>
#include <visualization_msgs/InteractiveMarkerInit.h>
#include <visualization_msgs/InteractiveMarkerControl.h>

#include <rtt/types/TypekitPlugin.hpp>
#include <rtt/types/StructTypeInfo.hpp>

namespace ros_integration {
  using namespace RTT;

    /** Declare all factory functions */
            void rtt_ros_addType_MarkerArray();
        void rtt_ros_addType_InteractiveMarkerUpdate();
        void rtt_ros_addType_InteractiveMarkerPose();
        void rtt_ros_addType_Marker();
        void rtt_ros_addType_MenuEntry();
        void rtt_ros_addType_InteractiveMarker();
        void rtt_ros_addType_ImageMarker();
        void rtt_ros_addType_InteractiveMarkerFeedback();
        void rtt_ros_addType_InteractiveMarkerInit();
        void rtt_ros_addType_InteractiveMarkerControl();

   
    /**
     * This interface defines the types of the realTime package.
     */
    class ROSvisualization_msgsTypekitPlugin
      : public types::TypekitPlugin
    {
    public:
      virtual std::string getName(){
          return std::string("ros-")+"visualization_msgs";
      }

      virtual bool loadTypes() {
          // call all factory functions
                  rtt_ros_addType_MarkerArray(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarkerUpdate(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarkerPose(); // factory function for adding TypeInfo.
        rtt_ros_addType_Marker(); // factory function for adding TypeInfo.
        rtt_ros_addType_MenuEntry(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarker(); // factory function for adding TypeInfo.
        rtt_ros_addType_ImageMarker(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarkerFeedback(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarkerInit(); // factory function for adding TypeInfo.
        rtt_ros_addType_InteractiveMarkerControl(); // factory function for adding TypeInfo.

          return true;
      }
      virtual bool loadOperators() { return true; }
      virtual bool loadConstructors() { return true; }
    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSvisualization_msgsTypekitPlugin )

